//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//						(c) 1998 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	NAN.h--- defines the NotANumber class that represents the ieee NaN.
//
//	DESCRIPTION:
//
//		bool isSet(float&) const;
//			// Detemines if a float is NaN.
//
//		bool isSet(float&) const;
//			// Detemines if a double is NaN.
//
//		bool isSet(const float&) const;
//			// Set a float to NaN.
//
//		bool isSet(const double&) const;
//			// Set a double to NaN.
//
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//		MT, 1998-10-01: 0.1.0: - first version
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/utils/src/NAN.h,v 1.1 1999/09/08 12:32:16 mthomas Exp $
///
#ifndef __NAN_H
#define __NAN_H


class NotANumber
{
	public :
		void set( float& ) const;
		void set( double& ) const;
		bool isSet( const float& ) const;
		bool isSet( const double& ) const;

};

extern NotANumber NaN;


#endif

