//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997 - 2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	SimpleScanner.h	--- defines the SimpleScanner class which represents
//                          a simple scanner.
//
//	DESCRIPTION:
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/utils/src/SimpleScanner.h,v 1.3 2001/07/12 15:00:00 ulammers Exp $
///

#ifndef SIMPLE_SCANNER_H
#define SIMPLE_SCANNER_H


#include "SimpleToken.h"


class SimpleScanner
{
	public :

		SimpleScanner( const std::string& s, const std::string& separators );
		~SimpleScanner();

		class Expected {
		public :
			Expected( const std::string& message );
			std::string message() const;
		private :
			std::string	_message;
		};

		bool 		eof() const;
		const 		SimpleToken& next() const;
		bool	 	nextIsCharacter( char thisCharacter ) const;
		bool 		nextIsString() const;
		SimpleToken accept();
		void 		skip();
		SimpleToken match( SimpleToken::Id id ) throw( Expected );
		SimpleToken match( char c ) throw( Expected );
		std::string	remainder() const;

	private :

		SimpleToken		_lookahead;
		void			fetchNextToken();
		std::string		_source;
		std::istream&	_ifs;
		std::string		_separators;
};

#endif

