//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997 - 2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	SimpleToken.h	--- defines the SimpleToken class which represents
//                          basic tokens.
//
//	DESCRIPTION:
//
//	USAGE EXAMPLES:
//
//	CHANGE HISTORY:
//
//	AUTHOR:
//		M.Thomas
//
//	REFERENCES:
//
//	$Header: /data/xmm02/cvsadmin/soc_repos/sas/packages/utils/src/SimpleToken.h,v 1.3 2001/07/12 15:00:00 ulammers Exp $
///

#ifndef SIMPLE_TOKEN_H
#define SIMPLE_TOKEN_H

#include <string>


class SimpleToken
{
	public:
		typedef enum Id {
				Undefined,	// None
				Character,	// char
				String,		// String
				Eof };		// None
		SimpleToken();
		SimpleToken( char v );
		SimpleToken( const std::string& v );
		SimpleToken( Id id );
		SimpleToken& operator=( const SimpleToken& );
		SimpleToken( const SimpleToken& );

		~SimpleToken();

		Id id() const;
		std::string idAsString() const;
		void id( Id id );
		void value( char v );
		void value( const std::string& v );
		char asChar() const;
		std::string asString() const;

		SimpleToken& operator=( char v );
		SimpleToken& operator=( const std::string& v );
		SimpleToken& operator=( Id id );

	protected :
		class Value;

	private :
		Value* 	_value;
		Id	_id;

};

#endif

