#include "QuotedString.h"
#include <strstream>
#include <cassert>

int main()
{
  std::string a,b;
  assert( a == b );

 {
  std::strstream s;
  QuotedString qs;
  s << "foo bar" << std::ends;
  s >> qs;
  assert(qs == std::string("foo"));
  s >> qs; 
  assert(qs == std::string("bar"));
  s >> qs;
  assert(!s);
 }
 
 {
  std::strstream s;
  QuotedString qs;
  s << "\"foo bar\" foo1" << std::ends;
  s >> qs;
  assert(qs == std::string("foo bar"));
  s >> qs;
  assert(qs == std::string("foo1"));
  s >> qs;
  assert(!s);
 }

 {
  QuotedString qs("foo bar");
  qs.quotes('(',')');
  std::strstream s;
  s << qs << std::ends;
  std::string ss;
  s >> ss;
  assert(ss == std::string("(foo"));
  s >> ss;
  assert(ss == std::string("bar)")+'\0'); // workaround for string bug: appends 0
 }

 {
  QuotedString qs;
  std::strstream s;
  s << qs << std::ends;
  std::string ss("foo");
  s >> ss;
  assert(ss == std::string("\"\"")+'\0'); // workaround for std::string bug: appends 0
  s >> ss;
  assert(!s);
 }

 {
  QuotedString qs;
  std::strstream s;
  s << qs << std::ends;
  QuotedString ss("foo");
  s >> ss;
  assert(ss.length() == 0);
 }
 return 0;
}



